import es, popuplib, random, gamethread, math
from dnds import *
info = es.AddonInfo()
info.name = 'D&DSource Mod - PVKII'
info.version = '0.0.2 Python'
info.url = 'http://addons.eventscripts.com/addons/view/dnds'
info.basename = 'pvkiidnds'
info.author = 'J3ff Hoogland'
#Begin Events
#Local Events
def player_spawn(ev):
    userid = int(ev['userid'])
    Character = dnds.getPlayer(userid)['Character']
    Playerlib = dnds.getPlayer(userid)['playerlib']
    Player = dnds.getPlayer(userid)['Player']
    for x in ['wind used','word used','glow used','glowing']:
        Player.key[x] = 0
    if len(Character.key['classes']):
        Class = Character.key['classes'].keys()[0]
    else:
        Class = None
    if Class:
        Playerlib.set('speed', dnds.Classes[Class]['speed'])
        Player.key['healing surges'] = dnds.Classes[Class]['healing surges']+dnds.statMod(Character.key['abilities']['Constitution'])
        if 'Durable' in Character.key['feats']:
            Player.key['healing surges'] += 2
        if 'Fase Runner' in Character.key['feats']:
            Playerlib.set('speed', Playerlib.get('speed')+.1)
        if 'Light Step' in Character.key['feats']:
            Playerlib.set('speed', Playerlib.get('speed')+.1)
        if 'Long Jumper' in Character.key['feats']:
            Player.key['long jump'] += .2
        es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', dnds.Classes[Class]['health']+(Character.key['abilities']['Constitution']*10))
        if 'Toughness' in Character.key['feats']:
            es.setplayerprop(userid, 'CPVK2Player.m_iMaxHealth', int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))+30)
        dnds.report('PVKII - %s Max Health %s'%(es.getplayername(userid), es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth')))
        gamethread.delayed(.25, es.setplayerprop, (userid, 'CBasePlayer.m_iHealth', es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth')))
        es.setplayerprop(userid, 'CPVK2Player.m_iMaxArmor', dnds.Classes[Class]['armor'])
        gamethread.delayed(.25, es.setplayerprop, (userid, 'CPVK2Player.m_ArmorValue', es.getplayerprop(userid,'CPVK2Player.m_iMaxArmor')))
        dnds.report('PVKII - %s Max Armor %s'%(es.getplayername(userid),dnds.Classes[Class]['armor']))
        Playerlib.set('model', dnds.Classes[Class]['model'])
        es.server.queuecmd('est_stripplayer %s'%userid)
        for x in dnds.Classes[Class]['weapons']:
            es.server.queuecmd('es_xdelayed .5 es_xgive %s %s'%(userid, x))
        for x in dnds.Classes[Class]['ammo']:
            gamethread.delayed(.25, es.setplayerprop, (userid, 'CBasePlayer.localdata.m_iAmmo.%s'%x, dnds.Classes[Class]['ammo'][x]))
def player_damage(ev):
    userid = int(ev['userid'])
    attacker = int(ev['attacker'])
    damage = int(ev['dmg_health'])
    PlayerHurt(userid, attacker, damage, ev['weapon'], dnds.getPlayer(userid)['Character'].key['classes'].keys(), dnds.getPlayer(userid)['Character'])
    if attacker:
        PlayerHit(attacker, userid, damage, ev['weapon'], dnds.getPlayer(attacker)['Character'].key['classes'].keys(), dnds.getPlayer(attacker)['Character'])
#End Local Events
#Global Events
#End Global Events
#End Events
#Commands Methods
#Cleric's word command
def wordcmd():
    #es.msg('wordcmd')
    userid = int(es.getcmduserid())
    dnds.report('%s ran the wordcmd in chat/console'%es.getplayername(userid))
    if not dnds.getPlayer(userid)['Player'].key['word used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            es.ServerVar('_dnds_temp').set(0)
            es.server.queuecmd('est_getviewplayer %s _dnds_temp'%userid)
            gamethread.delayed(.1, wordRun, (userid))
        else:
            es.tell(userid, '#multi', dnds.text('wordcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('wordcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordRun(userid):
    target = int(es.ServerVar('_dnds_temp'))
    #es.msg('Target = %s'%target)
    #es.msg('Word Run')
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 115+(level*5):
            dnds.getPlayer(userid)['Player'].key['word used'] = 1
            gamethread.delayed(15, wordWipe, (userid))
            HealingSurge(target)
            if level < 6:
                amount = random.randint(1, 6)
            elif level < 11:
                amount = random.randint(2, 12)
            elif level < 16:
                amount = random.randint(3, 18)
            elif level < 21:
                amount = random.randint(4, 24)
            elif level < 26:
                amount = random.randint(5, 30)
            else:
                amount = random.randint(6, 36)
            Heal(target, amount)
            es.tell(userid, '#multi', dnds.text('wordRun 1',{'name':es.getplayername(target),'amount':amount},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('wordRun 2',{'name':es.getplayername(target)},dnds.getPlayer(userid)['playerlib'].get('lang')))
def wordWipe(userid):
    dnds.getPlayer(userid)['Player'].key['word used'] = 0
    es.tell(userid, '#multi', dnds.text('wordWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#Cleric's glow command
def glowcmd():
    userid = int(es.getcmduserid())
    dnds.report('%s ran the glowcmd in chat/console'%es.getplayername(userid))
    if not dnds.getPlayer(userid)['Player'].key['glow used']:
        if 'Cleric' in dnds.getPlayer(userid)['Character'].key['classes'].keys():
            level = dnds.getPlayer(userid)['Character'].key['classes']['Cleric']['level']
            if level >= 5:
                dnds.getPlayer(userid)['Player'].key['glow used'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(15, glowSelf, userid)
                x1,y1,z1 = es.getplayerlocation(userid)
                team = es.getplayerteam(userid)
                for id in es.getUseridList():
                    if id != userid:
                        x2,y2,z2 = es.getplayerlocation(id)
                        if abs(x1-x2) < 240 and abs(y1-y2) < 240 and abs(z1-z2) < 240:
                            if team != es.getplayerteam(id):
                                dnds.getPlayer(id)['Player'].Damage(random.randint(14,33),userid)
                            else:
                                dnds.getPlayer(id)['Player'].key['glowing'] = 1
                                dnds.getPlayer(id)['Player'].Delayed(6, glowAlly, id)
            else:
                es.tell(userid, '#multi', dnds.text('glowcmd 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('glowcmd 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('glowcmd 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def glowSelf(userid):
    dnds.getPlayer(userid)['Player'].key['glow used'] = 0
    es.tell(userid, '#multi', dnds.text('glowSelf 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def glowAlly(id):
    dnds.getPlayer(id)['Player'].key['glowing'] = 0
#Begin +wind and -wind
def WindOn():
    userid = int(es.getcmduserid())
    if es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth') != es.getplayerprop(userid, 'CBasePlayer.m_iHealth'):
        if not dnds.getPlayer(userid)['Player'].key['wind used']:
            if dnds.getPlayer(userid)['Player'].key['healing surges']:
                dnds.getPlayer(userid)['Player'].key['wind on'] = 1
                dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, 1))
                dnds.getPlayer(userid)['Player'].Freeze()
            else:
                es.tell(userid, '#multi', dnds.text('WindOn 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
        else:
            es.tell(userid, '#multi', dnds.text('WindOn 2',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
    else:
        es.tell(userid, '#multi', dnds.text('WindOn 3',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
def WindOff():
    userid = int(es.getcmduserid())
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
def WindLoop(userid, count):
    if count < 3 and dnds.getPlayer(userid)['Player'].key['wind on']:
        dnds.getPlayer(userid)['Player'].Delayed(1, WindLoop, (userid, count+1))
    else:
        WindRun(userid)
def WindRun(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 1
    HealingSurge(userid)
    dnds.getPlayer(userid)['Player'].Unfreeze()
    dnds.getPlayer(userid)['Player'].key['wind on'] = 0
    dnds.getPlayer(userid)['Player'].Delayed(20, WindWipe, userid)
def WindWipe(userid):
    dnds.getPlayer(userid)['Player'].key['wind used'] = 0
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        es.tell(userid, '#multi', dnds.text('WindWipe 1',{},dnds.getPlayer(userid)['playerlib'].get('lang')))
#End Command Methods
#Global Methods
#Helps me break down events and pass in key info about users
def PlayerHurt(userid, attacker, damage, weapon, Classes, Character):
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 2:
            Heal(userid, damage/10)
def PlayerHit(userid, victim, damage, weapon, Classes, Character):
    if 'Cleric' in Classes:
        level = Character.key['classes']['Cleric']['level']
        if level >= 3:
            if not random.randrange(5):
                dnds.getPlayer(victim)['Player'].Damage(damage*.2,userid)
                if not random.randrange(3):
                    dnds.getPlayer(victim)['playerlib'].set('burn')
                    gamethread.delayed(3, dnds.getPlayer(victim)['playerlib'].set, "extinguish")
    if 'Power Attack' in Character.key['feats']:
        if weapon in Meele_Weapons:
            dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if 'Dwarven Weapon Training' in Character.key['feats']:
        if weapon in Axes:
            dnds.getPlayer(victim)['Player'].Damage(damage*.15,userid)
    if 'Eladrin Soldier' in Character.key['feats']:
        if weapon in Swords:
            dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
    if weapon in Meele_Weapons:
        dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(Character.key['abilities']['Strength'])),userid)
    if weapon in Ranged_Weapons:
        dnds.getPlayer(victim)['Player'].Damage(damage*(.5*dnds.statMod(Character.key['abilities']['Dexterity'])),userid)
    if dnds.getPlayer(id)['Player'].key['glowing']:
        dnds.getPlayer(victim)['Player'].Damage(damage*.1,userid)
def HealingSurge(userid):
    if dnds.getPlayer(userid)['Player'].key['healing surges']:
        if es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth') != es.getplayerprop(userid, 'CBasePlayer.m_iHealth'):
            Character = dnds.getPlayer(userid)['Character']
            Class = Character.key['classes'].keys()[0]
            Surge = ((dnds.Classes[Class]['health']+(Character.key['abilities']['Constitution']*10))/2)/2
            Heal(userid, Surge)
            dnds.getPlayer(userid)['Player'].key['healing surges'] -= 1
            es.tell(userid, '#multi', dnds.text('HealingSurge 1',{'surge':Surge,'remaining':dnds.getPlayer(userid)['Player'].key['healing surges']},dnds.getPlayer(userid)['playerlib'].get('lang')))
def Heal(userid, amount):
    if not dnds.getPlayer(userid)['playerlib'].get('isdead'):
        Health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
        MaxHealth = int(es.getplayerprop(userid, 'CPVK2Player.m_iMaxHealth'))
        if (Health+amount) <= MaxHealth:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', Health+amount)
        else:
            es.setplayerprop(userid, 'CBasePlayer.m_iHealth', MaxHealth)
#End Global Methods
#Load and Unload Methods
def load():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Begin Load')
    for x in dnds.Class_List:
        for i in range(1, 5):
            dnds.Classes[x]['info'].append('pvkii %s %s'%(x, i))
        for y in ClassSet[x]:
            dnds.Classes[x][y] = ClassSet[x][y]
    for i in range(1, 3):
        dnds.Abilities['Constitution']['info'].append('pvkii Constitution %s'%i)
    for a in ['Strength','Dexterity']:
        dnds.Abilities[a]['info'].append('pvkii %s 1'%a)
    for i in range(1, 5):
        dnds.Classes['Cleric']['powers1'].append('pvkii Cleric Powers1 %s'%i)
    for f in dnds.Feat_List:
        dnds.Feats[f]['info'].append('pvkii %s 1'%f)
    if not es.exists('clientcommand','+wind'):
        es.regclientcmd('+wind','dnds/games/pvkiidnds/WindOn')
    if not es.exists('clientcommand','-wind'):
        es.regclientcmd('-wind','dnds/games/pvkiidnds/WindOff')
    for x in ['word','glow']:
        #es.msg('Found %s Command for PVKIIDNDS'%x)
        if not es.exists('clientcommand', x):
            #es.msg('Reging %s as a client command'%x)
            es.regclientcmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        #else:
            #es.msg('%s is already client command'%x)
        if not es.exists('saycommand', x):
            #es.msg('Reging %s as a Client Say command'%x)
            es.regsaycmd(x, 'dnds/games/pvkiidnds/%scmd'%x)
        #else:
            #es.msg('%s is already client say command'%x)
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII End Load')
def unload():
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload Start')
    es.dbgmsg(0, '[Dungeons and Dragons] - PVKII Unload End')
Meele_Weapons = ['twosword','swordshield','archersword','cutlass','cutlass2','hook','bigaxe','axesword','twoaxe','vikingshield']
Ranged_Weapons = ['crossbow','longbow','flintlock','blunderbuss','throwaxe']
Swords = ['twosword','swordshield','archersword','cutlass','cutlass2','axesword','vikingshield']
Axes = ['bigaxe','axesword','twoaxe','throwaxe']
Special_Weapons = ['powderkeg','parrot']
ClassSet = {'Cleric':   {'health':120,
                        'armor':120,
                        'model':'player/heavyknight/heavyknight',
                        'weapons': ['weapon_twoaxe','weapon_swordshield'],
                        'ammo':{},
                        'healing surges':7,
                        'speed':1.0},
            'Fighter':  {'health':150,
                        'armor':150,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_bigaxe','weapon_crossbow','weapon_throwaxe'],
                        'ammo':{'004':10,'007':5},
                        'healing surges':9,
                        'speed':1.0},
            'Paladin':  {'health':150,
                        'armor':150,
                        'model':'player/heavyknight/heavyknight',
                        'weapons':['weapon_twosword','weapon_blunderbuss'],
                        'ammo':{'006':6},
                        'healing surges':10,
                        'speed':1.0},
            'Ranger':   {'health':120,
                        'armor':100,
                        'model':'player/huscarl/huscarl',
                        'weapons':['weapon_cutlass2','weapon_axesword','weapon_longbow'],
                        'ammo':{'005':30},
                        'healing surges':6,
                        'speed':1.0},
            'Rogue':    {'health':120,
                        'armor':80,
                        'model':'player/skirmisher/skirmisher',
                        'weapons':['weapon_cutlass','weapon_flintlock'],
                        'ammo':{'003':15},
                        'healing surges':6,
                        'speed':1.0},
            'Warlock':  {'health':120,
                        'armor':80,
                        'model':'player/bowman/bowman',
                        'weapons':['weapon_archersword','weapon_crossbow'],
                        'ammo':{'004':4},
                        'healing surges':6,
                        'speed':1.0},
            'Warlord':  {'health':120,
                        'armor':120,
                        'model':'player/berserker/berserker',
                        'weapons':['weapon_twosword','weapon_vikingshield','weapon_longbow'],
                        'ammo':{'005':15},
                        'healing surges':7,
                        'speed':1.0},
            'Wizard':   {'health':100,
                        'armor':40,
                        'model':'player/captain/captain',
                        'weapons':['weapon_archersword'],
                        'ammo':{},
                        'healing surges':6,
                        'speed':1.0}}
#End Load Methods